/* Test X Window suport */



#include <stdio.h>

#include "../3dfc.h"



/* Handler for the animation
**********************************************************/
void DrawHandler ( XtPointer, XtIntervalId * )
{
   // verify if exist frame buffer (it exit when window message Expose is received)
   if ( oAPP.m_pyVid ) {

      oAPP.m_pyVid [ oAPP.m_dwFrames % 10000 ] = oAPP.m_dwFrames % 200;
      //XPutPixel ( oAPP.m_pXImg, oAPP.m_dwFrames % 300, oAPP.m_dwFrames % 100, oAPP.m_dwFrames % 200 );
      oAPP.mShow ();

      oAPP.m_dwFrames ++;
   }

   XtAppAddTimeOut ( oAPP.m_stApContext, 1, DrawHandler, NULL );
}



/* The C entry point: parse command line and run engine
**********************************************************/
main ( INT nNumArgs, char *szArgs [] )
{
   // init window app
   oAPP.mCreate ( "Test CXWindowApp class - ESC exit", 400, 400, nNumArgs, szArgs );
   // oAPP is a global instance for the X app interface, see port/linxwin/xwinapp.cc

   // set palette
   CMem
       oPal ( 256 * 3 );
   for ( INT ncP = 0; ncP < 256; ncP += 3 ) {
      oPal.m_payMem [ ncP + 0 ] = ncP;
      oPal.m_payMem [ ncP + 1 ] = ncP;
      oPal.m_payMem [ ncP + 2 ] = ncP;
   }
   oAPP.mWritePal ( oPal );

   // execute
   XtAppAddTimeOut ( oAPP.m_stApContext, 300, DrawHandler, NULL );
   XtAppMainLoop ( oAPP.m_stApContext );
}
