/* Declare mem.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_MEM_H__



// signals file inclusion
#define __3DFC_MEM_H__



class CMem {

public:

   CMem ();
   CMem ( DWORD dwSize );
   CMem ( CMem& oMem );
   ~CMem ();

private:

   BOOL m_bDeleteSetBuffer;  // If the memory buffer is external,
   // setted by mSetBuffer, maybe is not good delete buffer.

public:

   BYTE* m_payMem;
   DWORD m_dwSize;

   void mCreate ( DWORD dwSize );
   void mDestroy ();
   BOOL mRealocate ( DWORD dwSize );
   void mSetObj ( CMem& oMem );
   void mSetBuffer ( void* pvBuff, DWORD dwSize, BOOL bDelete );
   void operator = ( CMem& oMem );
   BYTE operator [] ( DWORD dwPos );
   operator BYTE* ();
   operator void* ();
};



// end declarations
#endif
